package MTDDC::Tags;

sub _hdlr_query_loop {
    my ( $ctx, $args, $cond ) = @_;
    my $app = MT->instance();
    if (! ( ref $app ) =~ /^MT::App::/ ) {
        return '';
    }
    my $key  = $args->{ key };
    my $glue  = $args->{ glue };
    my @vals = $app->param( $key );
    return '' unless @vals;
    my $tokens = $ctx->stash( 'tokens' );
    my $builder = $ctx->stash( 'builder' );
    my $vars = $ctx->{ __stash }{ vars } ||= {};
    my $res = '';
    my $i = 1;
    for my $val ( @vals ) {
        $val = __to_utf8( $val );
        $val = __utf8_on( $val );
        local $vars->{ $key } = $val;
        local $vars->{ __counter__ } = $i;
        local $vars->{ __first__ } = 1 if $i == 1;
        local $vars->{ __last__ }  = 1 if $i == scalar @vals;
        local $vars->{ __odd__ }   = ( $i % 2 ) == 1;
        local $vars->{ __even__ }  = ( $i % 2 ) == 0;
        my $out = $builder->build( $ctx, $tokens, $cond );
        $res .= $out;
        $res .= $glue if $glue && $i != scalar @vals;
        $i++;
    }
    $res;
}

sub _hdlr_hello_world {
    my ( $ctx, $args, $cond ) = @_;
    my $world = $args->{ world } || 'World';
    return 'Hello ' . $world . '!';
}

sub _hdlr_query {
    my ( $ctx, $args, $cond ) = @_;
    my $app = MT->instance();
    if (! ( ref $app ) =~ /^MT::App::/ ) {
        return '';
    }
    my $key = $args->{ key };
    my $val = $app->param( $key );
    return '' unless $val;
    $val = __to_utf8( $val );
    $val = __utf8_on( $val );
    return $val;
}

sub _hdlr_rand {
    my ( $ctx, $args, $cond ) = @_;
    my $min = $args->{ min };
    my $max = $args->{ max } - $min + 1;
    my $rand = int( rand( $max ) );
    return $rand + $min;
}

sub _filter_addstring {
    my ( $str, $arg, $ctx ) = @_;
    return $str . $arg;
}

sub __utf8_on {
    my $text = shift;
    require Encode;
    if (! Encode::is_utf8( $text ) ) {
        Encode::_utf8_on( $text );
    }
    return $text;
}

sub __to_utf8 {
    my $text = shift;
    return MT::I18N::encode_text( $text, undef, 'utf-8' );
}

1;